{$A-,B-,E-,F-,I-,N-,O-,R-,S+,V-}
{ Pascal DisYCode. (c) 1989 YGP }

program DisYCode;
  uses CRT, Machine, CFH, Dis, UniPas;

  var Nmodules, Nsegments, Nprocs: integer;
      f: file;
      FName: string[79];
      Interactive: boolean;
      message: text;
      selected: record
	module, segment, proc: integer;
	Mname, Sname: alpha;
      end; { selected }

  procedure err(No: integer);
  begin
  if No = 0 then exit;
  write(message, #13#10'IO error No ', No);
  halt;
  end; { err }

  procedure UpCaseStr(var s: string);
    var l: byte;
  begin
  for l:= 1 to length(s) do s[l]:= UpCase(s[l]);
  end; { UpCaseStr }

  procedure ClrEos;
    var SvX, SvY, y: byte;
  begin
  SvX:= WhereX; SvY:= WhereY;
  ClrEol;
  for y:= SvY + 1 to 25 do
    begin GotoXY(1, y); clreol; end;
  GotoXY(SvX, SvY);
  end; { ClrEos }

  procedure Initialize;

    procedure ParseParameters;
      var i: Natural;
	  wrk: string;

      procedure HelpScreen;
      begin
      writeln;
      writeln('Usage: dy [-options] [filename[.pgm]] [-options]');
      writeln;
      writeln('-?, ? - display this help screen');
      writeln('-M=xxx  Module name (or -U=xxx Unit name).');
      writeln('-S=xxx  Segment name.');
      writeln('-P=xxx  Procedure No (1..255, 0 - all).');
      writeln('-All    DisYcode all.');
      halt;
      end; { HelpScreen }

    begin
    i:= ParamCount;
    while i > 0 do
      begin Dec(i);
      wrk:= System.ParamStr(ParamCount - i);
      if not (wrk[1] in ['-', '/']) and (wrk <> '?')
	then if FName <> ''
	       then begin write(message, ' *** Specify only one filename!');
		    HelpScreen;
		    end
	       else FName:= wrk
	else begin if wrk[1] in ['-', '/'] then delete(wrk, 1, 1);
	     if wrk = ''
	       then begin write(message, ' *** No option specified after -');
		    HelpScreen;
		    end;
	     UpCaseStr(wrk);
	     if wrk[1] = '?' then HelpScreen;
	     if (wrk[1] = 'M') and (wrk[2] = '=')
	       then begin delete(wrk, 1, 2);
		    end
	       else if (wrk[1] = 'S') and (wrk[2] = '=')
		 then begin
		      end
	       else if (wrk[1] = 'P') and (wrk[2] = '=')
		 then begin Interactive:= false;
		      end
	       else if wrk = 'ALL'
		 then begin
		      end
	       else begin write(message, ' *** Invalid option ', wrk);
		    HelpScreen;
		    end;
	     end;
      end; { while }
    if FName <> ''
      then if FName[length(FName)] = '.'
	     then Dec(FName[0])
	     else FName:= FName + '.pgm'
      else if not Interactive then HelpScreen;
    end; { ParseParameters }

  begin
  FillChar(Selected, SizeOf(Selected), 0);
  FName:= ''; Interactive:= true;
  ParseParameters;
  end; { Initialize }

  procedure ShowInfoLine;
  begin
  if FName = '' then begin write(message, 'File not specified!'); exit; end;
{File: .......................... Module: ........ Segment: ........ Proc: ...}
  write(message, #13);
  write(message, 'File: ');
  if length(FName) > 26
    then write(message, '...' + copy(FName, length(FName) - 23, 23))
    else write(message, FName, '': 26 - length(FName));
  if selected.module > 0
    then begin write(message, ' Module: ', selected.Mname);
	 if selected.segment >= 0
	   then write(message, ' Segment: ', selected.Sname);
	 if selected.proc > 0
	   then write(message, ' Proc: ', selected.proc);
	 end;
  if Nmodules = 0	then write(message, 'Not a CodeFile!')
  else if Nsegments = 0 then write(message, 'No Code Segments!')
  else if Nprocs = 0	then write(message, 'No procs?');
  end; { ShowInfoLine }

  procedure DisplayModules;
    const Month: packed array [0..11] of string[3] =
		 ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
		  'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
    var FNB: F_N_Buffer;
	MInfo: ModInfo;
	ec: ExitCode;
	errtxt: string;
  begin
  Nmodules:= 0;
  selected.module:= 0;
  selected.segment:= -1;
  selected.proc:= -1;
  assign(f, fname);
  if fname = '' then exit;
  GetFirstMod(f, FNB, MInfo, ec);
  if (ec in [IOerr, NotCode .. Block2large])
    then begin GetText(ec, errtxt); writeln(message, errtxt); exit; end;
  writeln(message, ' No  Module version     Date        Time');
  repeat Inc(Nmodules);
    if ec <> OK
      then begin GetText(ec, errtxt);
	   write(message, errtxt, '!'#7);
	   end
      else with MInfo do
	     begin write(message, Nmodules:3, name: 10, version: 6);
	     if Date.Year < 1989
	       then write(message, '  No Date    ')
	       else write(message, Date.day: 4, '.',
			  Month[Date.month], '.',
			  Date.Year);
	     if Time.Hours = 24
	       then write(message, '  No Time ')
	       else write(message, Time.Hours: 4, ':',
			  Time.minutes:2, ':',
			  Time.seconds:2);
	     if selected.module = 0
	       then begin selected.module:= Nmodules;
		    selected.mname:= name;
		    Nsegments:= FNB.CurrMD.MainSeg;
		    end;
	     end; { MInfo }
    writeln(message);
    GetNextMod(FNB, MInfo, ec);
  until ec = NoMore;
  close(f);
  if IOresult <> 0 then ;
  end; { DisplayModules }

  function GetNumber(Fch: char): word;
    var n: word;
	e: integer;
	w: string[9];
  begin
  w:= Fch; write(message, Fch);
  repeat
    repeat Fch:= UpCase(ReadKey);
      if (Fch = #0) and (ReadKey = #75) then Fch:= #8;
      if (Fch = #8) and (length(w) > 0)
	then begin write(message, #8' '#8);
	     dec(w[0]);
	     end
	else begin w:= w + Fch;
	     if w <> '$'
	       then begin Val(w, n, e);
		    if (e = 0) and (length(w) < 6)
		      then write(message, Fch)
		      else Dec(w[0]);
		    end
	       else write(message, '$');
	     end;
    until (Fch = #13) or (Fch = ' ') or (Fch = #27);
    Val(w, n, e); GetNumber:= n;
  until (Fch = #27) or (e = 0);
  if Fch = #27 then GetNumber:= $ffff;
  end; { GetNumber }

  procedure Dialog;
    type Command = (nothing, NewFile, Number, Accept, Quit, EscCmmd);
    var Cmmd: Command;
	ch: char;
	Num: integer;

    procedure GetCmmd;
    begin
    Cmmd:= nothing;
    repeat ch:= UpCase(ReadKey);
      case ch of
	#0:	  if ReadKey = #0 then ; { skip special key }

	'$',
	'0'..'9': Cmmd:= Number;

	'F':      Cmmd:= NewFile;
	' ', #13: Cmmd:= Accept;
	'Q':      Cmmd:= Quit;
	#27:	  Cmmd:= EscCmmd;
	end; { case }
    until Cmmd <> nothing;
    end; { GetCmmd }

    procedure SelectSegment;
      const Month: packed array [0..11] of string[3] =
		   ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
		    'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
      var FNB: F_N_Buffer;
	  MInfo: ModInfo;
	  ec: ExitCode;
	  errtxt: string;
	  n: integer;

      procedure SelectProc;
	var m: SegmentP;
	    pd: word;
      (*
      Segment = record
	 Check: alpha;
	 Wsz, Bsex: byte;
	 VerMaj, Ver.Min: byte;
	 TotSz: word;
	 CpoolSz: word;
	 unused: array [0..11] of byte;
	 PDict: word;
	 Cpool: word;
	 code: packed array [0..32000] of byte;
       end; { Segment }

       SegmentP = ^Segment;
      *)

	procedure DisProc;
	begin
	DisYproc(m, selected.proc);
	end; { DisProc }

      begin
      FNB.NextSeg:= FNB.CurrMD.MainSeg;
      GotoXY(1, 4); ClrEos;
      writeln;
      writeln('SegNo  SegName  Start  Size');
      GetNextSegment(FNB, ec);
      while selected.segment <> FNB.CurrSD.SegProc do GetNextSegment(FNB, ec);
      GetMem(m, FNB.CurrSD.Size);
      ReadInSeg(FNB, m, ec);

      pd:= m^.PDict;
      Nprocs:= word(addr(m^.code[pd])^);
      write('Nprocs: ', Nprocs);
      selected.proc:= 1;
      repeat GotoXY(1, 2); clreol; ShowInfoLine;
	GotoXY(1, 1); clreol;
	write(message, 'DisYcode[0.10]: <ProcNo>, <sp>/<cr>, <esc>');
	repeat GetCmmd;
	until Cmmd in [Number, Accept, EscCmmd];
	case Cmmd of
	  Number: begin GotoXY(1, 1); clreol;
		  write(message, 'Enter Procedure No: ');
		  Num:= GetNumber(ch);
		  if (0 < Num) and (Num <= Nprocs)
		    then begin selected.proc:= Num;
			 GotoXY(1, 4); ClrEos;
			 DisProc;
			 end;
		  end;

	  Accept: begin GotoXY(1, 4); ClrEos;
		  DisProc;
		  end;

	  end; { case }
      until Cmmd = EscCmmd;
      Cmmd:= nothing;
      end; { SelectProc }

    begin
    Nsegments:= 0; n:= 0;
    selected.segment:= -1;
    selected.proc:= -1;
    close(f); if IOresult <> 0 then ;
    assign(f, fname);
    if fname = '' then exit;
    GetFirstMod(f, FNB, MInfo, ec);
    if (ec in [IOerr, NotCode .. Block2large]) then exit;
    writeln(message, ' No  Module version     Date        Time');
    repeat Inc(n);
      if (ec = OK) and (n = selected.module)
	then begin
	     with MInfo do
	       begin write(message, Nmodules:3, name: 10, version: 6);
	       if Date.Year < 1989
		 then write(message, '  No Date    ')
		 else write(message, Date.day: 4, '.',
			    Month[Date.month], '.',
			    Date.Year);
	       if Time.Hours = 24
		 then write(message, '  No Time ')
		 else write(message, Time.Hours: 4, ':',
			    Time.minutes:2, ':',
			    Time.seconds:2);
	       Nsegments:= FNB.CurrMD.MainSeg;
	       end; { MInfo }
	     end;
      writeln;
      if Nsegments = 0 then GetNextMod(FNB, MInfo, ec);
    until (ec = NoMore) or (Nsegments <> 0);
    if Nsegments <> 0
      then repeat Nsegments:= 0; FNB.NextSeg:= FNB.CurrMD.MainSeg;
	     writeln;
	     writeln(message, 'SegNo  SegName  Start  Size');
	     GetNextSegment(FNB, ec);
	     repeat Inc(Nsegments);
	       with FNB.CurrSD do
		 begin writeln(SegProc: 3, SName: 12, Start: 6, Size: 6);
		 if selected.segment < 0
		   then begin selected.segment:= SegProc;
			selected.SName:= SName;
			end
		 end; { with }
		 GetNextSegment(FNB, ec);
	     until (ec = NoMore) or (ec = IOerr);
	     GotoXY(1, 2); clreol; ShowInfoLine;
	     GotoXY(1, 1); clreol;
	     write(message, 'DisYcode[0.10]: <SegmentNo>, <sp>/<cr>, <esc>');
	     repeat GetCmmd;
	     until Cmmd in [Number, Accept, EscCmmd];
	     case Cmmd of
	       Number:	begin GotoXY(1, 1); clreol;
			write(message, 'Enter Segment No: ');
			Num:= GetNumber(ch);
			if (0 <= Num) and (Num <= Nsegments)
			  then begin selected.segment:= Num;
			       SelectProc;
			       GotoXY(1, 4); ClrEos;
			       end;
			end;

	       Accept:	if Nsegments <> 0
			  then begin GotoXY(1, 4); ClrEos;
			       SelectProc;
			       GotoXY(1, 4); ClrEos;
			       end;

	       end; { case }
	   until Cmmd = EscCmmd;
    close(f); if IOresult <> 0 then ;
    end; { SelectSegment }

  begin
  ClrScr; GotoXY(1, 4);
  DisplayModules;
  repeat GotoXY(1, 2); clreol; ShowInfoLine;
    GotoXY(1, 1); clreol;
    write(message, 'DisYcode[0.10]: File, <ModuleNo>, <sp>/<cr>, Quit');
    GetCmmd;
    case Cmmd of
      Number:  begin GotoXY(1, 1); clreol;
	       write(message, 'Enter Module No: ');
	       Num:= GetNumber(ch);
	       if (0 < Num) and (Num <= Nmodules)
		 then begin selected.module:= Num;
		      GotoXY(1, 4); ClrEos;
		      SelectSegment;
		      GotoXY(1, 4); ClrEos;
		      DisplayModules;
		      end;
	       end;

      Accept:  if Nsegments <> 0
		 then begin GotoXY(1, 4); ClrEos;
		      SelectSegment;
		      GotoXY(1, 4); ClrEos;
		      DisplayModules;
		      end;

      NewFile: begin GotoXY(1, 1); clreol;
	       write(message, 'FileName: '); readln(FName);
	       if FName <> '' then
		 if FName[length(FName)] = '.'
		   then Dec(FName[0])
		   else FName:= FName + '.pgm';
	       GotoXY(1, 4); ClrEos;
	       DisplayModules;
	       end;

      end; { case }
  until Cmmd = Quit;
  GotoXY(1, 25); clreol;
  GotoXY(1, 24); clreol;
  end; { Dialog }

begin
assigncrt(message); rewrite(message);
writeln(message, 'DisYcode. Version 0.10. (c) 1989 YGP.');
Initialize;
if Interactive
  then Dialog
  else begin assign(Output, ''); rewrite(Output);
       dialog;
       Close(Output);
       end;
end. { DisYCode }